enum WF1_PROVISION = { wf1_a1, wf1_b1, wf1_b2, wf1_c1, wf1_d1 };
enum WF1_TASK = { wf1_A, wf1_B, wf1_C, wf1_D };
enum WF1_CHECKPOINT = { wf1_A_post, wf1_A_pre, wf1_B_post_1, wf1_B_post_2, wf1_B_post_3, wf1_B_post_4, wf1_B_pre_1, wf1_B_pre_2, wf1_B_pre_3, wf1_B_pre_4, wf1_C_post_1, wf1_C_post_2, wf1_C_post_3, wf1_C_post_4, wf1_C_pre_1, wf1_C_pre_2, wf1_C_pre_3, wf1_C_pre_4, wf1_D_post, wf1_D_pre };
array[WF1_TASK] of var WF1_PROVISION: wf1_selection;
array[WF1_CHECKPOINT] of var float: wf1_checkpoints_cost;
array[WF1_CHECKPOINT] of var float: wf1_checkpoints_resourceX;

array[WF1_PROVISION] of float: wf1_cost = [10.0, 1.0, 4.0, 1.0, 10.0];
array[WF1_PROVISION] of float: wf1_resourceX = [10.0, -4.0, -3.0, 1.0, 100.0];

var float: wf1_A_cost = wf1_cost[wf1_selection[wf1_A]];
var float: wf1_A_resourceX = wf1_resourceX[wf1_selection[wf1_A]];
var float: wf1_B_cost = wf1_cost[wf1_selection[wf1_B]];
var float: wf1_B_resourceX = wf1_resourceX[wf1_selection[wf1_B]];
var float: wf1_C_cost = wf1_cost[wf1_selection[wf1_C]];
var float: wf1_C_resourceX = wf1_resourceX[wf1_selection[wf1_C]];
var float: wf1_D_cost = wf1_cost[wf1_selection[wf1_D]];
var float: wf1_D_resourceX = wf1_resourceX[wf1_selection[wf1_D]];
set of WF1_CHECKPOINT: wf1_checkpoints_A_pre = { wf1_A_pre };
set of WF1_CHECKPOINT: wf1_checkpoints_A_post = { wf1_A_post };
set of WF1_CHECKPOINT: wf1_checkpoints_B_pre = { wf1_B_pre_1, wf1_B_pre_2, wf1_B_pre_3, wf1_B_pre_4 };
set of WF1_CHECKPOINT: wf1_checkpoints_B_post = { wf1_B_post_1, wf1_B_post_2, wf1_B_post_3, wf1_B_post_4 };
set of WF1_CHECKPOINT: wf1_checkpoints_C_pre = { wf1_C_pre_1, wf1_C_pre_2, wf1_C_pre_3, wf1_C_pre_4 };
set of WF1_CHECKPOINT: wf1_checkpoints_C_post = { wf1_C_post_1, wf1_C_post_2, wf1_C_post_3, wf1_C_post_4 };
set of WF1_CHECKPOINT: wf1_checkpoints_D_pre = { wf1_D_pre };
set of WF1_CHECKPOINT: wf1_checkpoints_D_post = { wf1_D_post };
constraint wf1_checkpoints_cost[wf1_A_pre] = sum([]);
constraint wf1_checkpoints_cost[wf1_A_post] = sum([wf1_A_cost]);
constraint wf1_checkpoints_cost[wf1_B_pre_1] = sum([wf1_A_cost]);
constraint wf1_checkpoints_cost[wf1_B_post_1] = sum([wf1_A_cost, wf1_B_cost]);
constraint wf1_checkpoints_cost[wf1_C_pre_1] = sum([wf1_A_cost]);
constraint wf1_checkpoints_cost[wf1_C_post_1] = sum([wf1_A_cost, wf1_C_cost]);
constraint wf1_checkpoints_cost[wf1_B_pre_2] = sum([wf1_A_cost, sum([wf1_B_cost, wf1_C_cost])]);
constraint wf1_checkpoints_cost[wf1_B_post_2] = sum([wf1_A_cost, sum([wf1_B_cost, wf1_C_cost]), wf1_B_cost]);
constraint wf1_checkpoints_cost[wf1_C_pre_2] = sum([wf1_A_cost, sum([wf1_B_cost, wf1_C_cost])]);
constraint wf1_checkpoints_cost[wf1_C_post_2] = sum([wf1_A_cost, sum([wf1_B_cost, wf1_C_cost]), wf1_C_cost]);
constraint wf1_checkpoints_cost[wf1_B_pre_3] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..2])]);
constraint wf1_checkpoints_cost[wf1_B_post_3] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..2]), wf1_B_cost]);
constraint wf1_checkpoints_cost[wf1_C_pre_3] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..2])]);
constraint wf1_checkpoints_cost[wf1_C_post_3] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..2]), wf1_C_cost]);
constraint wf1_checkpoints_cost[wf1_B_pre_4] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..3])]);
constraint wf1_checkpoints_cost[wf1_B_post_4] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..3]), wf1_B_cost]);
constraint wf1_checkpoints_cost[wf1_C_pre_4] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..3])]);
constraint wf1_checkpoints_cost[wf1_C_post_4] = sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..3]), wf1_C_cost]);
constraint wf1_checkpoints_cost[wf1_D_pre] = sum([sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..4])])]);
constraint wf1_checkpoints_cost[wf1_D_post] = sum([sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..4])]), wf1_D_cost]);
constraint wf1_checkpoints_resourceX[wf1_A_pre] = sum([]);
constraint wf1_checkpoints_resourceX[wf1_A_post] = sum([wf1_A_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_B_pre_1] = sum([wf1_A_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_B_post_1] = sum([wf1_A_resourceX, wf1_B_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_C_pre_1] = sum([wf1_A_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_C_post_1] = sum([wf1_A_resourceX, wf1_C_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_B_pre_2] = sum([wf1_A_resourceX, sum([wf1_B_resourceX, wf1_C_resourceX])]);
constraint wf1_checkpoints_resourceX[wf1_B_post_2] = sum([wf1_A_resourceX, sum([wf1_B_resourceX, wf1_C_resourceX]), wf1_B_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_C_pre_2] = sum([wf1_A_resourceX, sum([wf1_B_resourceX, wf1_C_resourceX])]);
constraint wf1_checkpoints_resourceX[wf1_C_post_2] = sum([wf1_A_resourceX, sum([wf1_B_resourceX, wf1_C_resourceX]), wf1_C_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_B_pre_3] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..2])]);
constraint wf1_checkpoints_resourceX[wf1_B_post_3] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..2]), wf1_B_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_C_pre_3] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..2])]);
constraint wf1_checkpoints_resourceX[wf1_C_post_3] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..2]), wf1_C_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_B_pre_4] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..3])]);
constraint wf1_checkpoints_resourceX[wf1_B_post_4] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..3]), wf1_B_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_C_pre_4] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..3])]);
constraint wf1_checkpoints_resourceX[wf1_C_post_4] = sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..3]), wf1_C_resourceX]);
constraint wf1_checkpoints_resourceX[wf1_D_pre] = sum([sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..4])])]);
constraint wf1_checkpoints_resourceX[wf1_D_post] = sum([sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..4])]), wf1_D_resourceX]);
var float: wf1_aggregated_cost = sum([sum([wf1_A_cost, sum([(sum([wf1_B_cost, wf1_C_cost])) | i1 in 1..4])]), wf1_D_cost]);
var float: wf1_aggregated_resourceX = sum([sum([wf1_A_resourceX, sum([(sum([wf1_B_resourceX, wf1_C_resourceX])) | i1 in 1..4])]), wf1_D_resourceX]);

constraint wf1_selection[wf1_A] in { wf1_a1 };
constraint wf1_selection[wf1_B] in { wf1_b1, wf1_b2 };
constraint wf1_selection[wf1_C] in { wf1_c1 };
constraint wf1_selection[wf1_D] in { wf1_d1 };

array[WF1_PROVISION] of string: wf1_provision_names = ["a1", "b1", "b2", "c1", "d1"];
output ["Selection graph for wf1:\n\t", "A=", wf1_provision_names[fix(wf1_selection[wf1_A])], " → ", "(", "B=", wf1_provision_names[fix(wf1_selection[wf1_B])], " | ", "C=", wf1_provision_names[fix(wf1_selection[wf1_C])], ")", "^4", " → ", "D=", wf1_provision_names[fix(wf1_selection[wf1_D])], "\n"];
output ["Aggregations for wf1:\n\tresourceX: \(wf1_aggregated_resourceX)\n\tcost: \(wf1_aggregated_cost)\n"];
